package sprzedaz.wydajnosc;

import java.math.BigDecimal;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Locale;
import java.util.Map;
import java.util.stream.Collectors;

import sprzedaz.MaszynaWczytujaca2;
import sprzedaz.Transakcja;

/* Korzystamy z przygotowanej metody w MaszynaWczytujaca2 - wersja ze strumieniem sekwencyjnym */
public class CzytajILicz5c {

	static void calaRobota() {
		try {
			Path plik = Paths.get(WyczarujPliki.DUZY_PLIK);
			Map<String, BigDecimal> sumyDouble = MaszynaWczytujaca2.dajStrumien(plik, false)
				.collect(Collectors.groupingBy(Transakcja::miasto,
					Collectors.mapping(Transakcja::wartosc,
						Collectors.reducing(BigDecimal.ZERO, BigDecimal::add))));

			sumyDouble.forEach((k, v) -> System.out.printf(Locale.US, "%12s - %12.2f\n", k, v));
			System.out.println();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		Pomiary.zmierzCzasDzalania(CzytajILicz5c::calaRobota);
		Pomiary.wypiszPamiec();
	}

}
